diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/tim.h ns-3.44/src/wifi/model/tim.h
--- ns-3.43/src/wifi/model/tim.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/tim.h	2025-03-09 16:55:49.799372700 -0700
@@ -17,8 +17,8 @@
 {
 
 /**
- * \brief The Traffic Indication Map Information Element
- * \ingroup wifi
+ * @brief The Traffic Indication Map Information Element
+ * @ingroup wifi
  *
  * The 802.11 Traffic Indication Map (see section 9.4.2.5 of 802.11-2020)
  *
@@ -34,7 +34,7 @@
     /**
      * Add the provided AID value to the list contained in the Virtual Bitmap
      *
-     * \param aid the AID value to add to this TIM's Virtual Bitmap
+     * @param aid the AID value to add to this TIM's Virtual Bitmap
      */
     void AddAid(uint16_t aid);
 
@@ -42,9 +42,9 @@
      * Add the AID values in the provided iterator range to the list contained
      * in the Virtual Bitmap
      *
-     * \tparam Iterator Type of iterator
-     * \param begin Starting position of the iterator range
-     * \param end Ending position of the iterator range
+     * @tparam Iterator Type of iterator
+     * @param begin Starting position of the iterator range
+     * @param end Ending position of the iterator range
      */
     template <typename Iterator>
     void AddAid(Iterator begin, Iterator end);
@@ -53,8 +53,8 @@
      * Check whether the bit corresponding to the provided AID is set in the
      * Virtual Bitmap included in this TIM
      *
-     * \param aid The AID value to look for
-     * \return True if the AID value is found in the Virtual Bitmap, false otherwise
+     * @param aid The AID value to look for
+     * @return True if the AID value is found in the Virtual Bitmap, false otherwise
      */
     bool HasAid(uint16_t aid) const;
 
@@ -62,8 +62,8 @@
      * Return the AID values, greater than the given AID value, whose corresponding bits are set
      * in the virtual bitmap.
      *
-     * \param aid the given AID value
-     * \return the AID values, greater than the given AID value, whose corresponding bits are set
+     * @param aid the given AID value
+     * @return the AID values, greater than the given AID value, whose corresponding bits are set
      *         in the virtual bitmap
      */
     std::set<uint16_t> GetAidSet(uint16_t aid = 0) const;
@@ -73,12 +73,12 @@
      * the first octet included in the Partial Virtual Bitmap. Note that the Bitmap Offset
      * subfield contains the number N1/2.
      *
-     * \return the Partial Virtual Bitmap offset
+     * @return the Partial Virtual Bitmap offset
      */
     uint8_t GetPartialVirtualBitmapOffset() const;
 
     /**
-     * \return the last non-zero octet in the virtual bitmap (denoted as N2 by the specs)
+     * @return the last non-zero octet in the virtual bitmap (denoted as N2 by the specs)
      */
     uint8_t GetLastNonZeroOctetIndex() const;
 
@@ -95,8 +95,8 @@
      * Obtain the index of the octet where the provided AID value should be
      * set in the Virtual Bitmap
      *
-     * \param aid the provided AID value
-     * \return the index of the octet where the provided AID value should be
+     * @param aid the provided AID value
+     * @return the index of the octet where the provided AID value should be
      *         set in the Virtual Bitmap
      */
     uint8_t GetAidOctetIndex(uint16_t aid) const;
@@ -104,8 +104,8 @@
     /**
      * Obtain an octet with a set bit, corresponding to the provided AID value
      *
-     * \param aid the provided AID value
-     * \return an octet with a set bit, corresponding to the provided AID value
+     * @param aid the provided AID value
+     * @return an octet with a set bit, corresponding to the provided AID value
      */
     uint8_t GetAidBit(uint16_t aid) const;
 
@@ -113,9 +113,9 @@
      * Obtain the AID value represented by a certain octet index and bit
      * position inside the Virtual Bitmap
      *
-     * \param octet the octet index in the Virtual Bitmap
-     * \param position the bit position in the octet of the Virtual Bitmap
-     * \return the corresponding AID value
+     * @param octet the octet index in the Virtual Bitmap
+     * @param position the bit position in the octet of the Virtual Bitmap
+     * @return the corresponding AID value
      */
     uint16_t GetAidFromOctetIndexAndBitPosition(uint16_t octet, uint8_t position) const;
 
@@ -123,12 +123,12 @@
      * The Bitmap Control field is optional if the TIM is carried in an S1G PPDU, while
      * it is always present when the TIM is carried in a non-S1G PPDU.
      *
-     * \return the value of the Bitmap Control field
+     * @return the value of the Bitmap Control field
      */
     uint8_t GetBitmapControl() const;
 
     /**
-     * \return a vector containing the Partial Virtual Bitmap octets
+     * @return a vector containing the Partial Virtual Bitmap octets
      */
     std::vector<uint8_t> GetPartialVirtualBitmap() const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/txop.cc ns-3.44/src/wifi/model/txop.cc
--- ns-3.43/src/wifi/model/txop.cc	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/txop.cc	2025-03-09 16:55:49.799372700 -0700
@@ -73,7 +73,7 @@
                           MakeUintegerAccessor((void(Txop::*)(uint32_t)) & Txop::SetMinCw,
                                                (uint32_t(Txop::*)() const) & Txop::GetMinCw),
                           MakeUintegerChecker<uint32_t>(),
-                          TypeId::OBSOLETE,
+                          TypeId::SupportLevel::OBSOLETE,
                           "Use MinCws attribute instead of MinCw")
             .AddAttribute(
                 "MinCws",
@@ -93,7 +93,7 @@
                           MakeUintegerAccessor((void(Txop::*)(uint32_t)) & Txop::SetMaxCw,
                                                (uint32_t(Txop::*)() const) & Txop::GetMaxCw),
                           MakeUintegerChecker<uint32_t>(),
-                          TypeId::OBSOLETE,
+                          TypeId::SupportLevel::OBSOLETE,
                           "Use MaxCws attribute instead of MaxCw")
             .AddAttribute(
                 "MaxCws",
@@ -114,7 +114,7 @@
                 MakeUintegerAccessor((void(Txop::*)(uint8_t)) & Txop::SetAifsn,
                                      (uint8_t(Txop::*)() const) & Txop::GetAifsn),
                 MakeUintegerChecker<uint8_t>(),
-                TypeId::OBSOLETE,
+                TypeId::SupportLevel::OBSOLETE,
                 "Use Aifsns attribute instead of Aifsn")
             .AddAttribute(
                 "Aifsns",
@@ -134,7 +134,7 @@
                           MakeTimeAccessor((void(Txop::*)(Time)) & Txop::SetTxopLimit,
                                            (Time(Txop::*)() const) & Txop::GetTxopLimit),
                           MakeTimeChecker(),
-                          TypeId::OBSOLETE,
+                          TypeId::SupportLevel::OBSOLETE,
                           "Use TxopLimits attribute instead of TxopLimit")
             .AddAttribute(
                 "TxopLimits",
@@ -358,6 +358,12 @@
     return GetLink(linkId).cw;
 }
 
+std::size_t
+Txop::GetStaRetryCount(uint8_t linkId) const
+{
+    return GetLink(linkId).staRetryCount;
+}
+
 void
 Txop::ResetCw(uint8_t linkId)
 {
@@ -365,6 +371,7 @@
     auto& link = GetLink(linkId);
     link.cw = GetMinCw(linkId);
     m_cwTrace(link.cw, linkId);
+    link.staRetryCount = 0;
 }
 
 void
@@ -372,10 +379,26 @@
 {
     NS_LOG_FUNCTION(this << linkId);
     auto& link = GetLink(linkId);
-    // see 802.11-2012, section 9.19.2.5
-    link.cw = std::min(2 * (link.cw + 1) - 1, GetMaxCw(linkId));
-    // if the MU EDCA timer is running, CW cannot be less than MU CW min
-    link.cw = std::max(link.cw, GetMinCw(linkId));
+
+    if (link.staRetryCount < m_mac->GetFrameRetryLimit())
+    {
+        // If QSRC[AC] is less than dot11ShortRetryLimit,
+        // - QSRC[AC] shall be incremented by 1.
+        // - CW[AC] shall be set to the lesser of CWmax[AC] and 2^QSRC[AC] × (CWmin[AC] + 1) – 1.
+        // (Section 10.23.2.2 of 802.11-2020)
+        ++link.staRetryCount;
+        link.cw =
+            std::min(GetMaxCw(linkId), (1 << link.staRetryCount) * (GetMinCw(linkId) + 1) - 1);
+    }
+    else
+    {
+        //  Else
+        // - QSRC[AC] shall be set to 0.
+        // - CW[AC] shall be set to CWmin[AC].
+        link.staRetryCount = 0;
+        link.cw = GetMinCw(linkId);
+    }
+
     m_cwTrace(link.cw, linkId);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/txop.h ns-3.44/src/wifi/model/txop.h
--- ns-3.43/src/wifi/model/txop.h	2024-10-09 16:41:10.128656900 -0700
+++ ns-3.44/src/wifi/model/txop.h	2025-03-09 16:55:49.799372700 -0700
@@ -44,9 +44,9 @@
 enum WifiMacDropReason : uint8_t; // opaque enum declaration
 
 /**
- * \brief Handles the packet queue and stores DCF/EDCA access parameters
+ * @brief Handles the packet queue and stores DCF/EDCA access parameters
  * (one Txop per AC).
- * \ingroup wifi
+ * @ingroup wifi
  *
  * This class handles the packet queue and stores DCF/EDCA access
  * parameters (one Txop per AC). It generates backoff values and stores the channel access status
@@ -59,8 +59,8 @@
     ~Txop() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
@@ -82,32 +82,32 @@
     /**
      * Check for QoS TXOP.
      *
-     * \returns true if QoS TXOP.
+     * @returns true if QoS TXOP.
      */
     virtual bool IsQosTxop() const;
 
     /**
      * Set the wifi MAC this Txop is associated to.
      *
-     * \param mac associated wifi MAC
+     * @param mac associated wifi MAC
      */
     virtual void SetWifiMac(const Ptr<WifiMac> mac);
     /**
      * Set MacTxMiddle this Txop is associated to.
      *
-     * \param txMiddle MacTxMiddle to associate.
+     * @param txMiddle MacTxMiddle to associate.
      */
     void SetTxMiddle(const Ptr<MacTxMiddle> txMiddle);
 
     /**
-     * \param callback the callback to invoke when an MPDU is dropped
+     * @param callback the callback to invoke when an MPDU is dropped
      */
     virtual void SetDroppedMpduCallback(DroppedMpdu callback);
 
     /**
      * Return the packet queue associated with this Txop.
      *
-     * \return the associated WifiMacQueue
+     * @return the associated WifiMacQueue
      */
     Ptr<WifiMacQueue> GetWifiMacQueue() const;
 
@@ -115,7 +115,7 @@
      * Set the minimum contention window size. For 11be multi-link devices,
      * set the minimum contention window size on the first link.
      *
-     * \param minCw the minimum contention window size.
+     * @param minCw the minimum contention window size.
      */
     void SetMinCw(uint32_t minCw);
     /**
@@ -123,7 +123,7 @@
      * Note that an empty <i>minCws</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param minCws the minimum contention window size for each link (links are sorted in
+     * @param minCws the minimum contention window size for each link (links are sorted in
      *               increasing order of link ID).
      */
     void SetMinCws(const std::vector<uint32_t>& minCws);
@@ -131,15 +131,15 @@
      * Set the minimum contention window size for the given link. Note that this function can
      * only be called after that links have been created.
      *
-     * \param minCw the minimum contention window size.
-     * \param linkId the ID of the given link
+     * @param minCw the minimum contention window size.
+     * @param linkId the ID of the given link
      */
     void SetMinCw(uint32_t minCw, uint8_t linkId);
     /**
      * Set the maximum contention window size. For 11be multi-link devices,
      * set the maximum contention window size on the first link.
      *
-     * \param maxCw the maximum contention window size.
+     * @param maxCw the maximum contention window size.
      */
     void SetMaxCw(uint32_t maxCw);
     /**
@@ -147,7 +147,7 @@
      * Note that an empty <i>maxCws</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param maxCws the maximum contention window size for each link (links are sorted in
+     * @param maxCws the maximum contention window size for each link (links are sorted in
      *               increasing order of link ID).
      */
     void SetMaxCws(const std::vector<uint32_t>& maxCws);
@@ -155,15 +155,15 @@
      * Set the maximum contention window size for the given link. Note that this function can
      * only be called after that links have been created.
      *
-     * \param maxCw the maximum contention window size.
-     * \param linkId the ID of the given link
+     * @param maxCw the maximum contention window size.
+     * @param linkId the ID of the given link
      */
     void SetMaxCw(uint32_t maxCw, uint8_t linkId);
     /**
      * Set the number of slots that make up an AIFS. For 11be multi-link devices,
      * set the number of slots that make up an AIFS on the first link.
      *
-     * \param aifsn the number of slots that make up an AIFS.
+     * @param aifsn the number of slots that make up an AIFS.
      */
     void SetAifsn(uint8_t aifsn);
     /**
@@ -171,7 +171,7 @@
      * Note that an empty <i>aifsns</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param aifsns the number of slots that make up an AIFS for each link (links are sorted in
+     * @param aifsns the number of slots that make up an AIFS for each link (links are sorted in
      *               increasing order of link ID).
      */
     void SetAifsns(const std::vector<uint8_t>& aifsns);
@@ -179,14 +179,14 @@
      * Set the number of slots that make up an AIFS for the given link. Note that this function
      * can only be called after that links have been created.
      *
-     * \param aifsn the number of slots that make up an AIFS.
-     * \param linkId the ID of the given link
+     * @param aifsn the number of slots that make up an AIFS.
+     * @param linkId the ID of the given link
      */
     void SetAifsn(uint8_t aifsn, uint8_t linkId);
     /**
      * Set the TXOP limit.
      *
-     * \param txopLimit the TXOP limit.
+     * @param txopLimit the TXOP limit.
      *        Value zero corresponds to default Txop.
      */
     void SetTxopLimit(Time txopLimit);
@@ -195,7 +195,7 @@
      * Note that an empty <i>txopLimits</i> is ignored, otherwise its size must match the number
      * of links.
      *
-     * \param txopLimits the TXOP limit for each link (links are sorted in increasing order of
+     * @param txopLimits the TXOP limit for each link (links are sorted in increasing order of
      *                   link ID).
      */
     void SetTxopLimits(const std::vector<Time>& txopLimits);
@@ -203,87 +203,87 @@
      * Set the TXOP limit for the given link. Note that this function can only be called after
      * that links have been created.
      *
-     * \param txopLimit the TXOP limit (must not be negative)
-     * \param linkId the ID of the given link
+     * @param txopLimit the TXOP limit (must not be negative)
+     * @param linkId the ID of the given link
      */
     void SetTxopLimit(Time txopLimit, uint8_t linkId);
     /**
      * Return the minimum contention window size. For 11be multi-link devices,
      * return the minimum contention window size on the first link.
      *
-     * \return the minimum contention window size.
+     * @return the minimum contention window size.
      */
     uint32_t GetMinCw() const;
     /**
      * Return the minimum contention window size for each link.
      *
-     * \return the minimum contention window size values.
+     * @return the minimum contention window size values.
      */
     std::vector<uint32_t> GetMinCws() const;
     /**
      * Return the minimum contention window size for the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the minimum contention window size.
+     * @param linkId the ID of the given link
+     * @return the minimum contention window size.
      */
     virtual uint32_t GetMinCw(uint8_t linkId) const;
     /**
      * Return the maximum contention window size. For 11be multi-link devices,
      * return the maximum contention window size on the first link.
      *
-     * \return the maximum contention window size.
+     * @return the maximum contention window size.
      */
     uint32_t GetMaxCw() const;
     /**
      * Return the maximum contention window size for each link.
      *
-     * \return the maximum contention window size values.
+     * @return the maximum contention window size values.
      */
     std::vector<uint32_t> GetMaxCws() const;
     /**
      * Return the maximum contention window size for the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the maximum contention window size.
+     * @param linkId the ID of the given link
+     * @return the maximum contention window size.
      */
     virtual uint32_t GetMaxCw(uint8_t linkId) const;
     /**
      * Return the number of slots that make up an AIFS. For 11be multi-link devices,
      * return the number of slots that make up an AIFS on the first link.
      *
-     * \return the number of slots that make up an AIFS.
+     * @return the number of slots that make up an AIFS.
      */
     uint8_t GetAifsn() const;
     /**
      * Return the number of slots that make up an AIFS for each link.
      *
-     * \return the number of slots that make up an AIFS for each link.
+     * @return the number of slots that make up an AIFS for each link.
      */
     std::vector<uint8_t> GetAifsns() const;
     /**
      * Return the number of slots that make up an AIFS for the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the number of slots that make up an AIFS.
+     * @param linkId the ID of the given link
+     * @return the number of slots that make up an AIFS.
      */
     virtual uint8_t GetAifsn(uint8_t linkId) const;
     /**
      * Return the TXOP limit.
      *
-     * \return the TXOP limit.
+     * @return the TXOP limit.
      */
     Time GetTxopLimit() const;
     /**
      * Return the TXOP limit for each link.
      *
-     * \return the TXOP limit for each link.
+     * @return the TXOP limit for each link.
      */
     std::vector<Time> GetTxopLimits() const;
     /**
      * Return the TXOP limit for the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the TXOP limit.
+     * @param linkId the ID of the given link
+     * @return the TXOP limit.
      */
     Time GetTxopLimit(uint8_t linkId) const;
     /**
@@ -292,7 +292,7 @@
      * of a packet after the maximum number of retransmissions has been
      * reached). By default, this resets the CW variable to minCW.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void ResetCw(uint8_t linkId);
     /**
@@ -300,14 +300,33 @@
      * a transmission failure. By default, this triggers a doubling
      * of CW (capped by maxCW).
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void UpdateFailedCw(uint8_t linkId);
 
     /**
+     * Get the current value of the CW variable for the given link. The initial
+     * value is minCw.
+     *
+     * @param linkId the ID of the given link
+     * @return the current value of the CW variable for the given link
+     */
+    uint32_t GetCw(uint8_t linkId) const;
+
+    /**
+     * Get the Station Short Retry Count (SSRC) maintained by non-QoS stations or the QoS STA
+     * Retry Count (QSRC) maintained by QoS STAs for each AC on the given link.
+     *
+     * @param linkId the ID of the given link
+     * @return the Station Short Retry Count (SSRC) maintained by non-QoS stations or the QoS STA
+     *         Retry Count (QSRC) maintained by QoS STAs for each AC on the given link
+     */
+    std::size_t GetStaRetryCount(uint8_t linkId) const;
+
+    /**
      * Notify that the given link switched to sleep mode.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     virtual void NotifySleep(uint8_t linkId);
     /**
@@ -318,7 +337,7 @@
      * When wake up operation occurs on a link, channel access on that link
      * will be restarted.
      *
-     * \param linkId the ID of the link
+     * @param linkId the ID of the link
      */
     virtual void NotifyWakeUp(uint8_t linkId);
     /**
@@ -328,7 +347,7 @@
 
     /* Event handlers */
     /**
-     * \param mpdu the given MPDU
+     * @param mpdu the given MPDU
      *
      * Store the given MPDU in the internal queue until it
      * can be sent safely.
@@ -339,15 +358,15 @@
      * Called by the FrameExchangeManager to notify that channel access has
      * been granted on the given link for the given amount of time.
      *
-     * \param linkId the ID of the given link
-     * \param txopDuration the duration of the TXOP gained (zero for DCF)
+     * @param linkId the ID of the given link
+     * @param txopDuration the duration of the TXOP gained (zero for DCF)
      */
     virtual void NotifyChannelAccessed(uint8_t linkId, Time txopDuration = Seconds(0));
     /**
      * Called by the FrameExchangeManager to notify the completion of the transmissions.
      * This method generates a new backoff and restarts access if needed.
      *
-     * \param linkId the ID of the link the FrameExchangeManager is operating on
+     * @param linkId the ID of the link the FrameExchangeManager is operating on
      */
     virtual void NotifyChannelReleased(uint8_t linkId);
 
@@ -356,15 +375,15 @@
      * used by this model. Return the number of streams (possibly zero) that
      * have been assigned.
      *
-     * \param stream first stream index to use.
+     * @param stream first stream index to use.
      *
-     * \return the number of stream indices assigned by this model.
+     * @return the number of stream indices assigned by this model.
      */
     int64_t AssignStreams(int64_t stream);
 
     /**
-     * \param linkId the ID of the given link
-     * \return the current channel access status for the given link
+     * @param linkId the ID of the given link
+     * @return the current channel access status for the given link
      */
     virtual ChannelAccessStatus GetAccessStatus(uint8_t linkId) const;
 
@@ -376,11 +395,11 @@
      * the PHY operating on the given link just woke up from sleep mode. The <i>checkMediumBusy</i>
      * argument is forwarded to the NeedBackoffUponAccess method of the ChannelAccessManager.
      *
-     * \param linkId the ID of the given link
-     * \param hadFramesToTransmit whether packets available for transmission were queued just
+     * @param linkId the ID of the given link
+     * @param hadFramesToTransmit whether packets available for transmission were queued just
      *                            before the occurrence of the event causing this channel access
      *                            request
-     * \param checkMediumBusy whether generation of backoff (also) depends on the busy/idle state
+     * @param checkMediumBusy whether generation of backoff (also) depends on the busy/idle state
      *                        of the medium
      */
     void StartAccessAfterEvent(uint8_t linkId, bool hadFramesToTransmit, bool checkMediumBusy);
@@ -395,8 +414,8 @@
         false; //!< generation of backoff is independent of the busy/idle state of the medium
 
     /**
-     * \param nSlots the number of slots of the backoff.
-     * \param linkId the ID of the given link
+     * @param nSlots the number of slots of the backoff.
+     * @param linkId the ID of the given link
      *
      * Start a backoff for the given link by initializing the backoff counter to
      * the number of slots specified.
@@ -405,8 +424,8 @@
 
     /**
      * Check if the Txop has frames to transmit over the given link
-     * \param linkId the ID of the given link.
-     * \return true if the Txop has frames to transmit.
+     * @param linkId the ID of the given link.
+     * @return true if the Txop has frames to transmit.
      */
     virtual bool HasFramesToTransmit(uint8_t linkId);
 
@@ -415,7 +434,7 @@
      * is normally called by the WifiMac of a non-AP MLD upon completing ML setup to have
      * its link IDs match AP MLD's link IDs.
      *
-     * \param links a set of pairs (from, to) each mapping a current link ID to the
+     * @param links a set of pairs (from, to) each mapping a current link ID to the
      *              link ID it has to become (i.e., link 'from' becomes link 'to')
      */
     void SwapLinks(std::map<uint8_t, uint8_t> links);
@@ -435,7 +454,7 @@
     };
 
     /**
-     * \return a const reference to user-provided access parameters
+     * @return a const reference to user-provided access parameters
      */
     const UserDefinedAccessParams& GetUserAccessParams() const;
 
@@ -450,7 +469,7 @@
     /**
      * Create a wifi MAC queue containing packets of the given AC
      *
-     * \param aci the index of the given AC
+     * @param aci the index of the given AC
      */
     virtual void CreateQueue(AcIndex aci);
 
@@ -458,51 +477,43 @@
     /**
      * Notify that access request has been received for the given link.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     virtual void NotifyAccessRequested(uint8_t linkId);
 
     /**
      * Generate a new backoff for the given link now.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     virtual void GenerateBackoff(uint8_t linkId);
     /**
      * Request access to the ChannelAccessManager associated with the given link
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void RequestAccess(uint8_t linkId);
 
     /**
-     * Get the current value of the CW variable for the given link. The initial
-     * value is minCw.
-     *
-     * \param linkId the ID of the given link
-     * \return the current value of the CW variable for the given link
-     */
-    uint32_t GetCw(uint8_t linkId) const;
-    /**
      * Return the current number of backoff slots on the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the current number of backoff slots
+     * @param linkId the ID of the given link
+     * @return the current number of backoff slots
      */
     uint32_t GetBackoffSlots(uint8_t linkId) const;
     /**
      * Return the time when the backoff procedure started on the given link.
      *
-     * \param linkId the ID of the given link
-     * \return the time when the backoff procedure started
+     * @param linkId the ID of the given link
+     * @return the time when the backoff procedure started
      */
     Time GetBackoffStart(uint8_t linkId) const;
     /**
      * Update backoff slots for the given link that nSlots has passed.
      *
-     * \param nSlots the number of slots to decrement
-     * \param backoffUpdateBound the time at which backoff should start
-     * \param linkId the ID of the given link
+     * @param nSlots the number of slots to decrement
+     * @param backoffUpdateBound the time at which backoff should start
+     * @param linkId the ID of the given link
      */
     void UpdateBackoffSlotsNow(uint32_t nSlots, Time backoffUpdateBound, uint8_t linkId);
 
@@ -516,16 +527,19 @@
         /// Destructor (a virtual method is needed to make this struct polymorphic)
         virtual ~LinkEntity() = default;
 
-        uint32_t backoffSlots{0};                  //!< the number of backoff slots
-        Time backoffStart{0};                      /**< the backoffStart variable is used to keep
-                                                        track of the time at which a backoff was
-                                                        started or the time at which the backoff
-                                                        counter was last updated */
-        uint32_t cw{0};                            //!< the current contention window
-        uint32_t cwMin{0};                         //!< the minimum contention window
-        uint32_t cwMax{0};                         //!< the maximum contention window
-        uint8_t aifsn{0};                          //!< the AIFSN
-        Time txopLimit{0};                         //!< the TXOP limit time
+        uint32_t backoffSlots{0};     //!< the number of backoff slots
+        Time backoffStart{0};         /**< the backoffStart variable is used to keep
+                                           track of the time at which a backoff was
+                                           started or the time at which the backoff
+                                           counter was last updated */
+        uint32_t cw{0};               //!< the current contention window
+        uint32_t cwMin{0};            //!< the minimum contention window
+        uint32_t cwMax{0};            //!< the maximum contention window
+        uint8_t aifsn{0};             //!< the AIFSN
+        Time txopLimit{0};            //!< the TXOP limit time
+        std::size_t staRetryCount{0}; //!< the Station Short Retry Count (SSRC) maintained by
+                                      //!< non-QoS stations or the QoS STA Retry Count (QSRC)
+                                      //!< maintained by QoS STAs for each AC
         ChannelAccessStatus access{NOT_REQUESTED}; //!< channel access status
 
         mutable class
@@ -538,13 +552,13 @@
     /**
      * Get a reference to the link associated with the given ID.
      *
-     * \param linkId the given link ID
-     * \return a reference to the link associated with the given ID
+     * @param linkId the given link ID
+     * @return a reference to the link associated with the given ID
      */
     LinkEntity& GetLink(uint8_t linkId) const;
 
     /**
-     * \return a const reference to the map of link entities
+     * @return a const reference to the map of link entities
      */
     const std::map<uint8_t, std::unique_ptr<LinkEntity>>& GetLinks() const;
 
@@ -567,7 +581,7 @@
     /**
      * Create a LinkEntity object.
      *
-     * \return a unique pointer to the created LinkEntity object
+     * @return a unique pointer to the created LinkEntity object
      */
     virtual std::unique_ptr<LinkEntity> CreateLinkEntity() const;
 
